c    "Copyright 2009 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac		!ac_KGrad_3D.f

      include 'common.3D'

c  ...  store useful arrays
c
c      icall=0     !Calculate normalising kernels

      do i=nstart,np


c       -- Kernel ReNormalisation ARRAYS --
     
        aM_a11(i)=0.    !Mi(1,1)
        aM_a12(i)=0.    !Mi(1,2)
        aM_a13(i)=0.    !Mi(1,3)
        aM_a21(i)=0.    !Mi(2,1)
        aM_a22(i)=0.    !Mi(2,2)
        aM_a23(i)=0.    !Mi(2,3)
        aM_a33(i)=0.    !Mi(3,3)
        aL_a11(i)=0.    !Li(1,1)
        aL_a12(i)=0.    !Li(1,2)
        aL_a13(i)=0.    !Li(1,3)
        aL_a21(i)=0.    !Li(2,1)
        aL_a22(i)=0.    !Li(2,2)
        aL_a23(i)=0.    !Li(2,3)
        aL_a33(i)=0.    !Li(3,3)


      enddo


c      -- Loop over cells to compute gradient correction Matrix --  
             
       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1  !Gives the alternative value to kind_p2 of kind_p1
              
       do lz=1,ncz
       do ly=1,ncy
       do lx=1,ncx
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet

         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

           lx2 = lx+1
           if(lx2.le.ncx)then
             call pre_celij(j1,j1+1,kind_p1,ini_kind_p2,ly2)     !East
           endif
       
           ly2 = ly+1
           if(ly2.le.ncy)then
             call pre_celij(j1,j1+ncx,kind_p1,ini_kind_p2,ly2)   !North
             lx2 = lx-1
             if(lx2.ge.1)call pre_celij(j1,j1+ncall1,
     &                                 kind_p1,ini_kind_p2,ly2)   !N-West
       
             lx2 = lx+1
             if(lx2.le.ncx)call pre_celij(j1,j1+ncall2,
     &                                 kind_p1,ini_kind_p2,ly2)   !N-East
           endif

c          -- Cells in the next XY  sheet --       
           lz2=lz+1
           if(lz2.le.ncz)then
       
             !- Same row -
             call pre_celij(j1,j1+nsheet,kind_p1,ini_kind_p2,ly2) !Up
       
             lx2=lx-1
             if(lx2.ge.1) call pre_celij(j1,j1+ncall3,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & West
       
             lx2=lx+1
             if(lx2.le.ncx) call pre_celij(j1,j1+ncall4,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & East
       
             !- Next row -
             ly2=ly+1
             if(ly2.le.ncy) then
               call pre_celij(j1,j1+ncall5,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North
       
               lx2=lx-1
               if(lx2.ge.1) call pre_celij(j1,j1+ncall6,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North-West
       
               lx2=lx+1
               if(lx2.le.ncx) call pre_celij(j1,j1+ncall7,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North-East
             endif
       
             !- Previous row -
             ly2=ly-1
             if(ly2.ge.1) then
               call pre_celij(j1,j1+ncall8,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & South
       
               lx2=lx-1
               if(lx2.ge.1) call pre_celij(j1,j1+ncall9,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & SouthWest
       
               lx2=lx+1
               if(lx2.le.ncx) call pre_celij(j1,j1+ncall10,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & SouthEast
             endif
       
           endif    !End of:   if(lz2.le.ncz)then
         endif    !End of:  if(nc(j1,kind_p1).gt.0) then
       
       enddo
       enddo
       enddo
       
       do j1=1,nct
           if(nc(j1,kind_p1).gt.0)
     +        call pre_self(j1,kind_p1,ini_kind_p2)
       enddo
       
c      -- Periodic Boundary Calls in Y-Direction --              
       if(i_periodicOBs(2).eq.1)then
         ly = ncy
         ly2 = ly+1
         do lz = 2,ncz-1
          do lx = 2,ncx-1
           j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
           call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
           call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
           call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
           call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
           call pre_celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
           call pre_celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
           call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
           call pre_celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
           call pre_celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          end do    !End of:  do lx = 2,ncx-1       
          !- Special Treatment for Corner Column Cells (lx=1 & lx=ncx) -
          !- Note this is for Y-Periodicity Only!               -
          !Norths & North-Easts of lx = 1 
          lx = 1
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call pre_celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
          call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call pre_celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          !Norths & North-Wests of lx = ncx 
          lx = ncx
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call pre_celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
          call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call pre_celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
         end do  !End of:  do lz = 2,ncz-1
         !- Special Treatment for Bottom & Top Sheets (lz=1 & lz=ncz) -
         !- Note this is for Y-Periodicity Only!               -
         ly = ncy
         ly2 = ly+1
         do lx = 2,ncx-1
          !Norths of lz = 1 
          lz = 1
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call pre_celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
          call pre_celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          !Norths of lz = ncz 
          lz = ncz
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call pre_celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
          call pre_celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
         enddo
         !- Special Treatment for Bottom & Top Corners 
         !- (lx,ly,lz=(1,ncy,1),(ncx,ncy,1),(ncx,ncy,ncz),(1,ncy,ncz) -
         !- Note this is for Y-Periodicity Only!                      -
         !- (1,ncy,1)     -
         lx = 1
         ly = ncy
         lz = 1
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
         call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
         call pre_celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
         !- (ncx,ncy,1)   -
         lx = ncx
         ly = ncy
         lz = 1
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
         call pre_celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
         call pre_celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
         !- (ncx,ncy,ncz) -
         lx = ncx
         ly = ncy
         lz = ncz
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call pre_celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
         call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
         call pre_celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
         !- (1,ncy,ncz)   -
         lx = 1
         ly = ncy
         lz = ncz
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call pre_celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call pre_celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
         call pre_celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
         call pre_celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
       endif   !End of:  if(i_periodicOBs(2).eq.1)then
       !-----  End of Y-Periodicity --------------------------   
       
       enddo   !End of:  do kind_p1=1,2

	 
      !-- Invert gradient correction Matrix --


      do i=nstart,np
	    if (i.gt.nb.and.iflag(i).gt.0) then !Only for Fluid particles
                                                !inside the limits
		   aM_a12(i)=0.5*(aM_a12(i)+aM_a21(i)) ! M should be symmetric
		   aM_a21(i)=aM_a12(i)    
		   aM_a13(i)=0.5*(aM_a13(i)+aM_a31(i)) ! M should be symmetric
		   aM_a31(i)=aM_a13(i)
		   aM_a23(i)=0.5*(aM_a23(i)+aM_a32(i)) ! M should be symmetric
		   aM_a32(i)=aM_a23(i)                             
             detM=aM_a11(i)*aM_a22(i)*aM_a33(i)+
     +            aM_a12(i)*aM_a23(i)*aM_a31(i)+
     +            aM_a13(i)*aM_a21(i)*aM_a32(i)-
     +            aM_a31(i)*aM_a22(i)*aM_a13(i)-
     +            aM_a11(i)*aM_a32(i)*aM_a23(i)-
     +            aM_a21(i)*aM_a12(i)*aM_a33(i) !Determinant of matrix M det(M)

             control=0.25
             if(abs(detM).gt.0.01.and.abs(aM_a11(i)).gt.control
     +         .and.abs(aM_a22(i)).gt.control
     +         .and.abs(aM_a33(i)).gt.control) then  !Only for "well conditioned" matrices  
		     one_over_detM = 1.0/detM

	!inverse matriz coefficients
       aL_a11(i)=(aM_a22(i)*aM_a33(i)-aM_a23(i)*aM_a32(i))*one_over_detM  
       aL_a21(i)=(aM_a31(i)*aM_a23(i)-aM_a21(i)*aM_a33(i))*one_over_detM  
       aL_a31(i)=(aM_a21(i)*aM_a32(i)-aM_a22(i)*aM_a31(i))*one_over_detM  
       aL_a12(i)=(aM_a13(i)*aM_a32(i)-aM_a12(i)*aM_a33(i))*one_over_detM  
       aL_a22(i)=(aM_a11(i)*aM_a33(i)-aM_a13(i)*aM_a31(i))*one_over_detM  
       aL_a32(i)=(aM_a12(i)*aM_a31(i)-aM_a11(i)*aM_a32(i))*one_over_detM  
	 aL_a13(i)=(aM_a12(i)*aM_a23(i)-aM_a13(i)*aM_a22(i))*one_over_detM  
       aL_a23(i)=(aM_a13(i)*aM_a21(i)-aM_a11(i)*aM_a23(i))*one_over_detM  
       aL_a33(i)=(aM_a11(i)*aM_a22(i)-aM_a12(i)*aM_a21(i))*one_over_detM  
c	         if_cor(i)=1
c             else    !No correction
               aL_a11(i) = 1.
               aL_a12(i) = 0.
               aL_a13(i) = 0.
               aL_a21(i) = 0.
               aL_a22(i) = 1.
               aL_a23(i) = 0.
               aL_a31(i) = 0.
               aL_a32(i) = 0.
               aL_a33(i) = 1.
c	         if_cor(i)=0
             endif
	    else !No correction
               aL_a11(i) = 1.
               aL_a12(i) = 0.
               aL_a13(i) = 0.
               aL_a21(i) = 0.
	         aL_a22(i) = 1.
               aL_a23(i) = 0.
               aL_a31(i) = 0.
               aL_a32(i) = 0.
               aL_a33(i) = 1.
c	        if_cor(i)=0
	    endif

 	enddo

	call ac_main
          
       return
       end


