c    "Copyright 2009 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

       subroutine check_limits_3D
       include 'common.3D'
       
       double precision dyp_dble
c       double precision ymin_container_double, ymax_container_double
       
       zmax=0.0
       ncases=0
       
       do i=nbp1,np   !do i=1,np ! Check if any fluid particle is over the box
          if(zp(i).gt.zmax) zmax=zp(i)
          if(iflag(i).eq.1)then
            if(real(xp(i)).gt.xmax_container.or.
     +         real(xp(i)).lt.xmin_container.or.
     +         zp(i).lt.zmin_container) then   
            write(80,*) 'Particle out of limits: ',i, 
     +      '  last X position: ',xp(i), 
     +      '  last Y position: ',yp(i), 
     +      '  last Z-position: ',zp(i)
            write(*,*) 'Particle out of limits: ',i, 
     +      '  last X position: ',xp(i), 
     +      '  last Y position: ',yp(i), 
     +      '  last Z-position: ',zp(i)
              iflag(i)=0
              ncases=ncases+1
              xp(i)=xtrash
              yp(i)=ytrash
              zp(i)=ztrash
              up(i)=0.
              vp(i)=0.
              wp(i)=0.
              um1(i)=0.
              uo(i)=0.
              vm1(i)=0.
              vo(i)=0.
              wm1(i)=0.
              wo(i)=0.
            else if(yp(i).gt.ymax_container.or.
     &              yp(i).lt.ymin_container)then
              if(i_periodicOBs(2).eq.1.and.i.gt.nb)then  !Replace Particle on other side of domain
                if(yp(i).gt.ymax_container)then
                  dyp_dble = dble(yp(i)) - ymax_container_double 
                  yp(i) = real(dyp_dble +ymin_container_double)
                else if(yp(i).lt.ymin_container)then
                  dyp_dble = ymin_container_double - dble(yp(i))   
                  yp(i) = real(ymax_container_double - dyp_dble)
                end if
              else
              write(80,*) 'Particle out of limits: ',i, 
     +        '  last X position: ',xp(i), 
     +        '  last Y position: ',yp(i), 
     +        '  last Z-position: ',zp(i)
              write(*,*) 'Particle out of limits: ',i, 
     +        '  last X position: ',xp(i), 
     +        '  last Y position: ',yp(i), 
     +        '  last Z-position: ',zp(i)
                iflag(i)=0
                ncases=ncases+1
                xp(i)=xtrash
                yp(i)=ytrash
                zp(i)=ztrash
                up(i)=0.
                vp(i)=0.
                wp(i)=0.
                um1(i)=0.
                uo(i)=0.
                vm1(i)=0.
                vo(i)=0.
                wm1(i)=0.
                wo(i)=0.
              end if
            end if
                
         endif   
       enddo
       
       !Check to see if Moving BPs moves across periodic boundaries
       if(i_periodicOBs(2).eq.1)then
         do i=nbf+1,nb
           if(zp(i).gt.zmax) zmax=zp(i)
           if(yp(i).gt.ymax_container.or.yp(i).lt.ymin_container)then
             if(yp(i).gt.ymax_container)then
               dyp_dble = dble(yp(i)) - ymax_container_double 
               yp(i) = real(dyp_dble +ymin_container_double)
             else if(yp(i).lt.ymin_container)then
               dyp_dble = ymin_container_double - dble(yp(i))   
               yp(i) = real(ymax_container_double - dyp_dble)
             end if
           endif
         enddo
       endif
       
       differ=(zmax-zcontrol)
   
       if (differ.gt.0) then     
          nn=int(differ*one_over_2h)+1
          zmax = zcontrol + 2*h*nn
          ncz = int( (zmax-zmin)*one_over_2h ) + 1
          nct = nsheet*ncz !3D
              do i=nct_ini+1,nct
                 nc(i,1)  = 0 !No Boundary Particles in these cells               
              enddo
       else
         zmax=zcontrol
          nct=nct_ini
          ncz=ncz_ini
       endif  
       
      if (ncases.ne.0) write(80,*) 'Number ',ncases,' time',time
      if (ncases.ne.0) write(*,*) 'Number ',ncases,' time',time

      if (ncases.ge.100) stop
             
       if(nct.gt.nct_max.or.ncz.lt.1)then
         write(80,*) ' '
         write(80,*)'ERROR in check_limits_3D.f'
         write(80,*)'nct.gt.nct_max.or.ncz.lt.1'
         write(80,*)'ncx/z    = ',ncx,ncz
         write(80,*)'nct= ',nct
         write(80,*)'nct_max ',nct_max
         write(80,*)'itime  ', itime
c        -- screen printout ---              
         write(*,*) ' '
         write(*,*)'ERROR in check_limits_3D.f'
         write(*,*)'nct.gt.nct_max.or.ncz.lt.1'
         write(*,*)'ncx/z    = ',ncx,ncz
         write(*,*)'nct= ',nct
         write(*,*)'nct_max ',nct_max
         write(*,*)'itime  ', itime
         stop
       endif
       
       
       return
       
       end